package aktrs.test.local;

import java.util.ArrayList;
import java.util.List;

import aktrs.rt.Actor;

public class ScatterActor extends Actor {
	private List<Actor> workers = new ArrayList<Actor>();
	private int roundRobinCurrentIndex = 0;

	@Override
	protected void onMessage(Object message, Actor sender) {
		if (message instanceof StartScatterGather) {
			StartScatterGather m = (StartScatterGather) message;
			for (int i = 1; i <= m.numberoOfWorkers; i++) {
				workers.add(getSystem().summon("/" + getSystem().id + "/worker" + i, WorkerActor.class));
			}
			Actor gathererActor = getSystem().summon("/" + getSystem().id + "/gatherer", GatherActor.class);
			for (Actor actor : workers) {
				tell(actor, GathererAssignment.create(gathererActor.getAddress()));
			}
			tell(gathererActor, message);
		} else if (message instanceof CalculateFibonacciMessage) {
			CalculateFibonacciMessage m = (CalculateFibonacciMessage) message;
			roundRobinCurrentIndex++;
			if (roundRobinCurrentIndex > (workers.size() - 1)) {
				roundRobinCurrentIndex = 0;
			}
			tell(workers.get(roundRobinCurrentIndex), m);
		}
	}
}
