package aktrs.test.local;

import java.io.IOException;
import java.util.logging.Level;

import aktrs.rt.Actor;
import aktrs.rt.ActorSystem;

/**
 * Simple actor test
 * 
 * @author Raffaele Arecchi
 *
 */

public class Test1 {

	public static void main(String[] args) throws SecurityException, IOException {
		ActorSystem system = new ActorSystem("my-system");
		system.setLogLevel(Level.FINE);

		Actor slowHelloActor = system.summon("/my-system/slow-hello-actor", SlowHelloActor.class);
		Actor systemActor = system.evoke("/my-system/system");

		TestMessage message1 = new TestMessage();
		message1.mx = "Gino";
		TestMessage message2 = new TestMessage();
		message2.mx = "Pino";
		TestMessage message3 = new TestMessage();
		message3.mx = "Tino";
		systemActor.tell(slowHelloActor, message1);
		systemActor.tell(slowHelloActor, message2);
		systemActor.tell(slowHelloActor, message3);
		systemActor.tell(slowHelloActor, "Giorgio");
		system.shutdown("no reason");
	}
}
