package aktrs.test.local;

import java.math.BigInteger;
import java.util.logging.Level;

import aktrs.rt.Actor;
import aktrs.rt.ActorSystem;

/**
 * Parallel actors processing
 * 
 * @author Raffaele Arecchi
 *
 */

public class Test2 {

	public static void main(String[] args) {
		ActorSystem sys = new ActorSystem("fib");
		sys.setLogLevel(Level.FINE);

		Actor supervisor = sys.summon("/fib/fibonacciSupervisor", FibonacciSupervisor.class);
		Actor fib1 = sys.summon("/fib/fibonacciCalc1", FibonacciActor.class);
		Actor fib2 = sys.summon("/fib/fibonacciCalc2", FibonacciActor.class);
		supervisor.tell(fib1, CalculateFibonacciMessage.create(new BigInteger("38")));
		supervisor.tell(fib2, CalculateFibonacciMessage.create(new BigInteger("39")));
	}

	public static class FibonacciSupervisor extends Actor {
		Integer counter = new Integer(0);

		@Override
		protected void onMessage(Object message, Actor sender) {
			if (message instanceof ResultFibonacciMessage) {
				counter++;
				System.out.println(sender.getAddress() + " response is " + ((ResultFibonacciMessage) message).number);
				if (counter.equals(2)) {
					getSystem().shutdown("fibonacci completed");
				}
			}
		}
	}

}
