package aktrs.test.local;

import java.math.BigInteger;
import java.util.logging.Level;

import aktrs.rt.Actor;
import aktrs.rt.ActorSystem;

/**
 * Scatter-gather actor test
 * 
 * @author Raffaele Arecchi
 *
 */

public class Test4 {

	public static void main(String[] args) {
		ActorSystem sys = new ActorSystem("scatter-gather-sys");
		sys.setLogLevel(Level.FINE);

		Actor scatterer = sys.summon("/scatter-gather-sys/scatterer", ScatterActor.class);

		// run
		sys.evoke("/scatter-gather-sys/system").tell(scatterer, StartScatterGather.create(3));

		sys.evoke("/scatter-gather-sys/system").tell(scatterer, CalculateFibonacciMessage.create(new BigInteger("36")));
		sys.evoke("/scatter-gather-sys/system").tell(scatterer, CalculateFibonacciMessage.create(new BigInteger("37")));
		sys.evoke("/scatter-gather-sys/system").tell(scatterer, CalculateFibonacciMessage.create(new BigInteger("38")));
	}

}
