package aktrs.test.local;

import aktrs.rt.Actor;

public class WorkerActor extends Actor {
	private Actor to;

	public WorkerActor() {
	}

	@Override
	protected void onMessage(Object message, Actor sender) {
		if (message instanceof GathererAssignment) {
			GathererAssignment m = (GathererAssignment) message;
			to = getSystem().evoke(m.gathererAddress);
		} else if (message instanceof CalculateFibonacciMessage) {
			CalculateFibonacciMessage m = (CalculateFibonacciMessage) message;
			ResultFibonacciMessage response = ResultFibonacciMessage.create(SlowFibonacci.nthFibonacci(m.number));
			System.out.println("Actor " + address.toString() + " computed fibonacci of " + m.number + " as " + response.number);
			tell(to, response);
		}
	}

}
